﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.5
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Dim gs_voucherdatems As Long
	
	Dim xui As XUI
	Private mask As MaskEditText
	
	Dim is_status As String

	Private btn_clear As Button
	Private btn_retrieve As Button
	Private btn_save As Button
	Private ilbl_allow As Label
	Private ilbl_backclick As Label
	Private ilbl_billamount As Label
	Private ilbl_bookname As Label
	Private ilbl_calendervoucherdate As Label
	Private ilbl_clickbranchname As Label
	Private ilbl_doctorname As Label
	Private ilbl_heading As Label
	Private ilbl_number As Label
	Private ilbl_patientname As Label
	Private ilbl_patientregno As Label
	Private ilbl_voucherdate As Label
	Private ip_booknamepanel As Panel
	Private ip_editbillamount As EditText
	Private ip_editdoctorname As EditText
	Private ip_editnumber As EditText
	Private ip_editpatientname As EditText
	Private ip_editregno As EditText
	Private ip_headingpanel As Panel
	Private ip_itemnamepanel As Panel
	Private ip_numberpanel As Panel
	Private ip_stockentrypanel As Panel
	Private ip_stockindentfullpanel As Panel
'	Private ip_voucherdatelabel As Label
	Private ip_voucherdatepanel As Panel
	Private ipnl_allow As Panel
	Private ipnl_billamount As Panel
	Private ipnl_doctorname As Panel
	Private ipnl_line As Panel
	Private ipnl_patientname As Panel
	Private ispnr_allowcredit As B4XComboBox
	Private ispnr_bookname As B4XComboBox
	Private ip_voucherdatelabel As EditText
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("allowcredit_labbilling")
	
	mask.Initialize("Mask" , ip_voucherdatelabel, "##-##-####")
	
	ip_voucherdatelabel.Color = Colors.Transparent
	ip_editnumber.Color = Colors.Transparent
	
	AllowCredit
	
End Sub

Sub B4XPage_Appear
	ilbl_patientregno.Visible = False
	ip_itemnamepanel.Visible = False
	ilbl_patientname.Visible = False
	ipnl_patientname.Visible = False
	ilbl_doctorname.Visible = False
	ipnl_doctorname.Visible = False
	ilbl_billamount.Visible = False
	ipnl_billamount.Visible = False
	ilbl_allow.Enabled = False
	ilbl_allow.Visible = False
	ipnl_allow.Enabled = False
	ipnl_allow.Visible = False
	btn_save.Enabled = False
End Sub

Sub B4XPage_Foreground
	
End Sub

Sub AllowCredit
	ispnr_allowcredit.SetItems(Array As String("Yes", "No"))
	ispnr_bookname.SetItems(Array As String("Book 1", "Book 2"))
	
	ispnr_allowcredit.cmbBox.DropdownBackgroundColor = 0xFF2F3C7E
	ispnr_allowcredit.cmbBox.DropdownTextColor = Colors.White
	
	ispnr_bookname.cmbBox.DropdownBackgroundColor = 0xFF2F3C7E
	ispnr_bookname.cmbBox.DropdownTextColor = Colors.White
	
End Sub

Private Sub ilbl_calendervoucherdate_Click
	If Sender Is Label Then
		Private locLabel As Label = Sender
		locLabel.SetColorAnimated(50, Colors.Transparent, Colors.ARGB(60,36,83,144))
		Sleep(50)
		locLabel.SetColorAnimated(50, Colors.ARGB(60,36,83,144), Colors.Transparent)
	End If

	Dim Dd As DateDialog
	Dd.Year = DateTime.GetYear(gs_voucherdatems)
	Dd.Month = DateTime.GetMonth(gs_voucherdatems)
	Dd.DayOfMonth = DateTime.GetDayOfMonth(gs_voucherdatems)
	Dim fda As Object = Dd.ShowAsync("", "SELECT DATE", "Yes", "Cancel", "", Null, False)
	Wait For (fda) Dialog_Result(result As Int)
	
	If result = DialogResponse.POSITIVE Then
		Dim is_date As String
		is_date = Dd.DayOfMonth
		If is_date.Length < 2 Then
			is_date = "0" & is_date
		End If
		Dim is_month As String
		is_month = Dd.Month
		If is_month.Length < 2 Then
			is_month = "0" & is_month
		End If
		ip_voucherdatelabel.Text = is_date & "-" & is_month & "-" & Dd.Year
		DateTime.DateFormat = "dd-MM-yyyy"
		gs_voucherdatems = DateTime.DateParse(ip_voucherdatelabel.Text)
	End If
End Sub

Private Sub ilbl_backclick_Click
	B4XPages.ShowPage("mainmenu_allowcredit")
End Sub

Private Sub btn_retrieve_Click
	
	If ip_editnumber.Text = "" Then
		Dim cs As CSBuilder
		MsgboxAsync(cs.Initialize.Append("Please Enter a ").Bold.Append("Bill Number").Pop , "Empty Bill No.")
		Return
	End If
	
	is_status = "E"
	ilbl_patientregno.Visible = True
	ip_itemnamepanel.Visible = True
	ilbl_patientname.Visible = True
	ipnl_patientname.Visible = True
	ilbl_doctorname.Visible = True
	ipnl_doctorname.Visible = True
	ilbl_billamount.Visible = True
	ipnl_billamount.Visible = True
	ilbl_allow.Enabled = True
	ilbl_allow.Visible = True
	ipnl_allow.Enabled = True
	ipnl_allow.Visible = True
		
End Sub

Private Sub btn_clear_Click
	ip_editnumber.Text = ""
End Sub

Private Sub ip_voucherdatelabel_EnterPressed
	If IsValidDate(ip_voucherdatelabel.Text) = True Then
		DateTime.DateFormat = "dd-MM-yyyy"
		Dim sec As Long = DateTime.DateParse(ip_voucherdatelabel.Text)
		gs_voucherdatems = sec
		ip_voucherdatelabel.Text = DateTime.Date(sec)
	Else If IsValidDate(ip_voucherdatelabel.Text) = False Then
		gs_voucherdatems = DateTime.Now
		MsgboxAsync("Invalid Date", "Error")
		ip_voucherdatelabel.RequestFocus
	End If
End Sub

Private Sub ip_voucherdatelabel_FocusChanged (HasFocus As Boolean)
	If IsValidDate(ip_voucherdatelabel.Text) = True Then
		DateTime.DateFormat = "dd-MM-yyyy"
		Dim sec As Long = DateTime.DateParse(ip_voucherdatelabel.Text)
		gs_voucherdatems = sec
		ip_voucherdatelabel.Text = DateTime.Date(sec)
	Else If IsValidDate(ip_voucherdatelabel.Text) = False Then
		gs_voucherdatems = DateTime.Now
		MsgboxAsync("Invalid Date", "Error")
		ip_voucherdatelabel.RequestFocus
	End If
End Sub

Sub IsValidDate(s As String) As Boolean
	Try
		DateTime.DateFormat = "dd-MM-yyyy"
		DateTime.DateParse(s)
		Return True
	Catch
		Return False
	End Try
End Sub

Sub DateToYear(as_date As String) As String
	'Convert Date-Month-Year Format To Year-Month-Date
	Dim l As Long
	DateTime.DateFormat = "dd-mm-yyyy"     ' "29-08-1961
	Dim datestring As String = as_date
	l = DateTime.DateParse(datestring)
	DateTime.DateFormat = "yyyy-mm-dd"  ' "1961-08-29"
	as_date = DateTime.Date(l)
	Return as_date
End Sub
